
--MOD VG_PGA --																																																		
--MOD Version: 1.0 FS2015--																																																				
--MOD Author:  Vanguard --																																													
--MOD date: 14/12/2014 --																																																																																												
--Copyright © 2014 Vanguard --																																														

VG_PDA = {};
VG_PDA.moddir = g_currentModDirectory;
VG_PDA.modName = g_currentModName;
if VG_PDA.moddir:sub(-1) ~= '/' then
	VG_PDA.moddir = VG_PDA.moddir .. '/';
end;

-- forward dec'l
VG_PDA.screens = {};

if #InputBinding.actions[InputBinding.TOGGLE_PDA].keys1 == 1 and 
   InputBinding.actions[InputBinding.TOGGLE_PDA].keys1[1] == InputBinding.actions[InputBinding.VG_PDA_TOGGLE_PDA].keys1[1] then
  table.insert(InputBinding.actions[InputBinding.TOGGLE_PDA].keys1, 1,  Input.KEY_lshift);
  InputBinding.preprocessInputActions();
end;

-----------self.foliageStateOverlay = createFoliageStateOverlay("foliageState", 256, 256)
-----------resetFoliageStateOverlay(self.foliageStateOverlay)
--[[
orig_setTextBold = setTextBold;
function setTextBold()
  orig_setTextBold(true);
end;
]]
function VG_PDA:loadMap(name)
  self.doOnce = false;
  self.showPDA=false;
  self.showFrame = true;
  self.currentScreen = 1;
  self.showIngameMap = true;
  
  self.overlayPosX = 0.003;
  self.overlayPosY = 0.005;
  self.overlayWidth = 0.40;
  self.overlayHeight = self.overlayWidth * 0.5 * g_screenAspectRatio;
  self.Overlay = Overlay:new("VG_PDA_frame", Utils.getFilename('VG_PDA.png', VG_PDA.moddir), self.overlayPosX, self.overlayPosY, self.overlayWidth, self.overlayHeight);

  local pixelWidth = self.overlayWidth / 1024.0;
  local pixelHeight = pixelWidth * g_screenAspectRatio;
  
  self.screenOffsetX = self.overlayPosX + (92 * pixelWidth); -- 92
  self.screenOffsetY = self.overlayPosY + (46 * pixelHeight); --46
  self.screenWidth = 840 * pixelWidth; -- 840
  self.screenHeight = 372 * pixelHeight; -- 420 - 48
  self.lineSpacing = (372 / 12) * pixelHeight;
  self.screenFont = self.lineSpacing * 0.85;
  self.titleFontSize = 48 * .80 * pixelHeight;
  self.titlePosY = self.screenOffsetY + self.screenHeight + (48 * .20 * pixelHeight);
  self.screenCols = {}
  local posX = self.screenOffsetX + (22 * pixelWidth);
  self.colWidth = (self.screenWidth - (44 * pixelWidth)) / 4
  self.screenCols[1] = posX;
  self.screenCols[2] = posX + self.colWidth; 
  self.screenCols[3] = posX + self.colWidth * 2;
  self.screenCols[4] = posX + self.colWidth * 3;
end;

function VG_PDA:deleteMap()
  -- Cleanup
  if self.Overlay ~= nil then
    self.Overlay:delete();
  end;
end;

function VG_PDA:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VG_PDA:keyEvent(unicode, sym, modifier, isDown)
end;

function VG_PDA:hide()
  self.screens[self.currentScreen].target:deactivate();
  self.showPDA = false;
  g_currentMission.ingameMap:setVisible(self.showIngameMap);
end;

function VG_PDA:show()
  self.showPDA = true;
  if g_inGameMenu.showIngameMap ~= nil then
    self.showIngameMap = g_inGameMenu.showIngameMap;
  else
    self.showIngameMap = true;
  end;
  if g_currentMission.ingameMap:getIsFullSize() then 
    g_currentMission.ingameMap:toggleSize(); 
  end;
  g_currentMission.ingameMap:setVisible(false);
  self.screens[self.currentScreen].target:activate();
end;

function VG_PDA:changeScreen(index)
  self.screens[self.currentScreen].target:deactivate();
  self.currentScreen = index;
  if self.currentScreen > #self.screens then
    self.currentScreen = 1;
  elseif self.currentScreen < 1 then
    self.currentScreen = #self.screens;
  end;
  self.screens[self.currentScreen].target:activate();
end;

function VG_PDA:update()
  if not self.doOnce then
    self.doOnce = true;
  end;
  
  if self.showPDA == true then
    if InputBinding.hasEvent(InputBinding.VG_PDA_TOGGLE_PDA) then
      self:hide();
    elseif InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_SCREEN) then
      self:changeScreen(self.currentScreen + 1);
    elseif InputBinding.hasEvent(InputBinding.VG_PDA_PREV_SCREEN) then
      self:changeScreen(self.currentScreen - 1);
    end;
  else -- showPDA == false
    if InputBinding.hasEvent(InputBinding.VG_PDA_TOGGLE_PDA) then
      self:show();
    end;
  end;
  for i=1, 10 do
    local binding = "VG_PDA_SCREEN_" .. i;
    if InputBinding.hasEvent(InputBinding[binding]) then
      if i > #self.screens then break; end;
      
      if self.showPDA == true then
        if self.currentScreen == i then
          self:hide();
        else
          self:changeScreen(i);
        end;
      else -- showPDA == false
          self.currentScreen = i;
          self:show();
      end;
    end;
  end;
  if self.showPDA == true then
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAClose"), InputBinding.VG_PDA_TOGGLE_PDA);
    if #self.screens > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDA_NEXT_SCREEN"), InputBinding.VG_PDA_NEXT_SCREEN);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDA_PREV_SCREEN"), InputBinding.VG_PDA_PREV_SCREEN);
    end;
  end;
end;

function VG_PDA:draw()
  if self.showPDA == true then
    if self.currentScreen ~= #self.screens then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextScreen"), InputBinding.TOGGLE_PDA);
    else
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAClose"), InputBinding.TOGGLE_PDA);
    end;
    if self.showFrame then
      self.Overlay:render();
      setTextColor(1, 1, 1, 1);
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(true);
      renderText(self.screenCols[1], self.titlePosY, self.titleFontSize, self.screens[self.currentScreen].title);
      setTextBold(false);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(self.screenCols[4] + self.colWidth, self.titlePosY + self.lineSpacing * 0.15, self.screenFont, string.format("%.2d:%.2d", g_currentMission.environment.currentHour, g_currentMission.environment.currentMinute));
    end;
  end;
end;

addModEventListener(VG_PDA);

-- #######################
-- # VG_PDA_Screen
-- #######################
VG_PDA_Screen = {};
local VG_PDA_Screen_mt = Class(VG_PDA_Screen);

function VG_PDA_Screen:registerScreen(title, index)
  if index ~= nil then
    table.insert(VG_PDA.screens, index, {title = title, target = self});
  else
    table.insert(VG_PDA.screens, {title = title, target = self});
  end;
end;
function VG_PDA_Screen:deregisterScreen(index)
  if index == nil then  
    for i=1, #VG_PDA.screens do
      if VG_PDA.screens[i].target == self then
        index = i;
        break;
      end;
    end;
  end;
  
  if index ~= nil then
    if VG_PDA.currentScreen == index then
      VG_PDA:changeScreen(index + 1);   
    end;
    table.remove(VG_PDA.screens, index);
    if (VG_PDA.currentScreen > index) then
      VG_PDA.currentScreen = VG_PDA.currentScreen - 1;
    end;
  end;
end;

function VG_PDA_Screen.getWidth()
  return VG_PDA.screenWidth;
end;
function VG_PDA_Screen.getHeight()
  return VG_PDA.screenHeight;
end;
function VG_PDA_Screen.getOffsetX()
  return VG_PDA.screenOffsetX;
end;
function VG_PDA_Screen.getOffsetY()
  return VG_PDA.screenOffsetY;
end;
function VG_PDA_Screen.getScreenFont()
  return VG_PDA.screenFont;
end;
function VG_PDA_Screen.getLineSpacing()
  return VG_PDA.lineSpacing;
end;
function VG_PDA_Screen.getScreenCols()
  return VG_PDA.screenCols;
end;
function VG_PDA_Screen.getColWidth()
  return VG_PDA.colWidth;
end;
function VG_PDA_Screen.getMargin()
  return VG_PDA.lineSpacing * 0.15;
end;
function VG_PDA_Screen.getTopY()
  return VG_PDA.screenOffsetY + VG_PDA.screenHeight;
end;

function VG_PDA_Screen:setTitle(title)
  for i, screen in ipairs(VG_PDA.screens) do
    if (screen.target == self) then
      screen.title = title;
      break;
    end;
  end;
end;
function VG_PDA_Screen.setTextColorRed()
  setTextColor(0.8069, 0.0097, 0.0097, 1);
end;
function VG_PDA_Screen.setTextColorGreen()
  setTextColor(0.2705, 0.6514, 0.0802, 1);
end;
function VG_PDA_Screen.setTextColorYellow()
  setTextColor(1, 0.5, 0, 1);
end;
function VG_PDA_Screen.setTextColorBlue()
  setTextColor(0.0742, 0.4341, 0.6939, 1);
end;
function VG_PDA_Screen.setTextColorBlack()
  setTextColor(0, 0, 0, 1);
end;
function VG_PDA_Screen.setTextColorWhite()
  setTextColor(1, 1, 1, 1);
end;

function VG_PDA_Screen:showFrame(show)
  if show == false then
    VG_PDA.showFrame = false;
  else
    VG_PDA.showFrame = true;
  end;
end;
  
function VG_PDA_Screen:loadMap()
end;
function VG_PDA_Screen:activate()
end;
function VG_PDA_Screen:deactivate()
end;
function VG_PDA_Screen:draw()
end;
function VG_PDA_Screen:deleteMap()
end;
function VG_PDA_Screen:mouseEvent()
end;
function VG_PDA_Screen:keyEvent()
end;
function VG_PDA_Screen:update()
end;
--setTextWrapWidth 
VG_PDA_Screen.textWrap = function (str, fontsize, width)
 local here = 1
 local numLines = 1;
 return str:gsub("(%s+)()(%S+)()",
  function (sp, st, word, fi)
    if utf8Strlen(str:sub(here, fi-1)) > getTextLineLength(fontsize, str:sub(here, fi-1) ,width) then
      here = st;
      numLines = numLines + 1;
      return "\n"..word;
    end;
  end ), numLines;
end;


-- #######################
-- # VG_PDA_mapScreen
-- #######################
local VG_PDA_mapScreen = VG_PDA_Screen:new();
function VG_PDA_mapScreen:loadMap()
  self.isActive = false;
  self.minMapWidth = g_currentMission.ingameMap.minMapWidth;
  self.minMapHeight = g_currentMission.ingameMap.minMapHeight;
  self.minMapVisWidth = g_currentMission.ingameMap.minMapVisWidth;
  self.mapPosX = g_currentMission.ingameMap.mapPosX;
  self.mapPosY = g_currentMission.ingameMap.mapPosY;
  self.iconZoom = g_currentMission.ingameMap.iconZoom;
end;
function VG_PDA_mapScreen:activate()
  self.isActive = true;
  g_currentMission.ingameMap.minMapWidth = VG_PDA_Screen.getWidth();
  g_currentMission.ingameMap.minMapHeight = VG_PDA_Screen.getHeight();
  g_currentMission.ingameMap.minMapVisWidth = 0.7;
  g_currentMission.ingameMap.mapVisWidthMin = 0.7;
  g_currentMission.ingameMap.mapPosX = VG_PDA_Screen.getOffsetX();
  g_currentMission.ingameMap.mapPosY = VG_PDA_Screen.getOffsetY();
  g_currentMission.ingameMap.iconZoom = 1.28;
  g_currentMission.ingameMap.mapOverlay:setPosition(VG_PDA_Screen.getOffsetX(), VG_PDA_Screen.getOffsetY());
  g_currentMission.ingameMap:setSize(VG_PDA_Screen.getWidth(), VG_PDA_Screen.getHeight());
  g_currentMission.ingameMap:setVisible(true);
end;
function VG_PDA_mapScreen:deactivate()
  self.isActive = false;
  g_currentMission.ingameMap.minMapWidth = self.minMapWidth;
  g_currentMission.ingameMap.minMapHeight = self.minMapHeight;
  g_currentMission.ingameMap.minMapVisWidth = self.minMapVisWidth;
  g_currentMission.ingameMap.mapVisWidthMin = self.minMapVisWidth;
  g_currentMission.ingameMap.mapPosX = self.mapPosX;
  g_currentMission.ingameMap.mapPosY = self.mapPosY;
  g_currentMission.ingameMap.iconZoom = self.iconZoom;
  g_currentMission.ingameMap.mapOverlay:setPosition(self.mapPosX, self.mapPosY);
  g_currentMission.ingameMap:setSize(self.minMapWidth, self.minMapHeight);
  g_currentMission.ingameMap:setVisible(false);
  if g_currentMission.ingameMap:getIsFullSize() then 
    g_currentMission.ingameMap:toggleSize(); 
  end;
  self:showFrame(true);
end;
function VG_PDA_mapScreen:update()
  if self.isActive then
    if g_currentMission.ingameMap.isFullSize == true then
      self:showFrame(false);
    else
      self:showFrame(true);
    end;
  end;
end;

VG_PDA_mapScreen:registerScreen(g_i18n:getText("Map"));
addModEventListener(VG_PDA_mapScreen);

-- #######################
-- # VG_PDA_weatherScreen
-- #######################

local VG_PDA_weatherScreen = VG_PDA_Screen:new();
function VG_PDA_weatherScreen:loadMap()
  self.isActive = false;
  self.showDay = 1;
  self.showNews = 1;
  self.weatherOverlays = {};
  self.newsText = {};
  self.currentDay = 0;
  
  self.overlay = Overlay:new("VG_PDA_weatherScreen", Utils.getFilename('VG_PDA_weather.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
  
  g_currentMission.environment:addDayChangeListener(self);
end;

function VG_PDA_weatherScreen:activate()
  self.isActive = true;
  if self.currentDay ~= g_currentMission.environment.currentDay then
    self.currentDay = g_currentMission.environment.currentDay;
    
    local screenCols = self.getScreenCols();
    local topY, lineSpacing, colWidth, screenFont, margin = 
      self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont(), self.getMargin();  
      
    for i=1, 8 do
      local rainType = g_currentMission.environment:getRainTypeIdAtDay(self.currentDay + i - 1) or "sun";
      local iconFile = "dataS2/menu/hud/hud_" .. rainType .. ".png";
      if (self.weatherOverlays[i] ~= nil) then self.weatherOverlays[i]:delete(); end;
      self.weatherOverlays[i] = Overlay:new(
        "weatherIcon"..i,
        iconFile,
        screenCols[((i-1) % 4) + 1] + (colWidth - lineSpacing * 2 / g_screenAspectRatio) / 2, topY - lineSpacing * 3 - margin,
        lineSpacing * 2 / g_screenAspectRatio, lineSpacing * 2);      
    end;
  end;
  if self.showNews > #g_currentMission.ingameNews then
    self.showNews = 1;
  end;
end;

function VG_PDA_weatherScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_weatherScreen:dayChanged()
  if self.isActive then
    self:activate();
  end;
end;

function VG_PDA_weatherScreen:deleteMap()
  for _, overlay in ipairs(self.weatherOverlays) do
    overlay:delete();
  end;
  self.weatherOverlays = nil;
  
  self.overlay:delete();
  self.overlay = nil;

  self.newsText = nil;
end;

function VG_PDA_weatherScreen:update()
  if self.isActive then
    
    if self.showDay == 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextDays"), InputBinding.VG_PDA_NEXT_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showDay = 5;
      end;
    else
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevDays"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showDay = 1;
      end;
    end;
    if #g_currentMission.ingameNews > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDACycleNews"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showNews = self.showNews + 1;
        if self.showNews > #g_currentMission.ingameNews then
          self.showNews = 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_weatherScreen:draw()
  if self.isActive then
    self.overlay:render();
    local screenCols = self.getScreenCols();
    local topY, lineSpacing, colWidth, screenFont, margin = 
      self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont(), self.getMargin();
    local col = 0;
    local degrees = g_i18n:getText("TemperatureSymbol");
    local highs = g_currentMission.environment.weatherTemperaturesDay;
    local lows = g_currentMission.environment.weatherTemperaturesNight;
    for i=self.showDay, self.showDay + 3 do
      col = col + 1;
      self.weatherOverlays[i]:render();
      self.setTextColorWhite();
      setTextAlignment(RenderText.ALIGN_CENTER);
      local dayOfWeek = math.mod(self.currentDay + i - 2, 7) + 1;
      local dayName;
      if i == 1 then
        dayName = g_i18n:getText("financesToday");
      else
        dayName = g_i18n:getText("financesDay" .. dayOfWeek);
      end;
      renderText(screenCols[col] + colWidth / 2, topY - lineSpacing, screenFont, dayName);
      self.setTextColorRed();
      renderText(screenCols[col] + colWidth / 2, topY - lineSpacing * 4, screenFont, string.format("%d %s", highs[i], degrees));
      self.setTextColorBlue();
      renderText(screenCols[col] + colWidth / 2, topY - lineSpacing * 5, screenFont, string.format("%d %s", lows[i], degrees));
    end;
    
    self.setTextColorWhite();
    if #g_currentMission.ingameNews == 0 then
      setTextAlignment(RenderText.ALIGN_CENTER);
      setTextBold(true);
      renderText(screenCols[3], topY - lineSpacing * 7, screenFont, g_i18n:getText("IngameNews_NoNewsTitle"));
      setTextBold(false);
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * 8, screenFont, g_i18n:getText("IngameNews_NoNewsText"));
    else
      local ingameNews = g_currentMission.ingameNews;
      setTextAlignment(RenderText.ALIGN_CENTER);
      setTextBold(true);
      renderText(screenCols[3], topY - lineSpacing * 7, screenFont, ingameNews[self.showNews].title);
      setTextBold(false);
      if #ingameNews > 1 then
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + colWidth - margin, topY - lineSpacing * 11, screenFont, "("..g_i18n:formatNumber(self.showNews).."/"..g_i18n:formatNumber(#ingameNews)..")");
      end;
      setTextAlignment(RenderText.ALIGN_LEFT);
      local text = self.textWrap(ingameNews[self.showNews].text, screenFont, screenCols[4] + colWidth - screenCols[1]);
      renderText(screenCols[1], topY - lineSpacing * 8, screenFont, text);
    end;
  end;
end;

VG_PDA_weatherScreen:registerScreen(g_i18n:getText("weatherForecast") .. " / " .. g_i18n:getText("IngameNews"));
addModEventListener(VG_PDA_weatherScreen);


-- #######################
-- # VG_PDA_storageScreen
-- #######################

local VG_PDA_storageScreen = VG_PDA_Screen:new();
function VG_PDA_storageScreen:loadMap()
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  self.fruitsInStorage = {};
  self.fruitOverlays = {};
  self.fruitsInFarmTriggers = {};
  
  self.isActive = false;
  self.showFruit = 1;

  
  self.overlay = Overlay:new("VG_PDA_storageScreen", Utils.getFilename('VG_PDA_storage.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
  
  for _, location in pairs(g_currentMission.tipTriggers) do
    if (location.isFarmTrigger) then
      for index, _ in pairs(location.acceptedFillTypes) do
        if not location.animalHusbandry then
          local fruit = Fillable.fillTypeIndexToDesc[index];
          self.fruitsInFarmTriggers[index] = fruit;
        end;
      end;
    end;
  end;
    
  local i = 0;
  for _, fruit in pairs(self.fruitsInFarmTriggers) do
    i = i + 1;
    table.insert(self.fruitsInStorage, fruit.index);
  
    table.insert(self.fruitOverlays, 
      Overlay:new(
        fruit.name, 
        fruit.hudOverlayFilenameSmall, 
        self.getOffsetX(), self.getTopY() - self.getLineSpacing() * ((i-1) % 11 + 2),
        self.getLineSpacing() / g_screenAspectRatio, self.getLineSpacing()));
   self.fruitOverlays[i]:setColor(0, 0, 0, 1);
  end;
end;

function VG_PDA_storageScreen:deleteMap()
  self.fruitsInStorage = nil;
  
  for _, overlay in ipairs(self.fruitOverlays) do
    overlay:delete();
  end;
  
  self.overlay:delete();
  self.overlay = nil;
  
  self.fruitOverlays = nil;
end;

function VG_PDA_storageScreen:activate()
  self.isActive = true;
end;

function VG_PDA_storageScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_storageScreen:update()
  if self.isActive then
    if #self.fruitsInStorage > 11 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextFruits"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevFruits"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showFruit = self.showFruit + 11;
        if self.showFruit > #self.fruitsInStorage then
          self.showFruit = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showFruit = self.showFruit - 11;
        if self.showFruit < 1 then
          self.showFruit = math.floor((#self.fruitsInStorage - 1) / 11) * 11 + 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_storageScreen:draw()
  if not self.isActive then return end;
  self.overlay:render();  
  local screenCols = self.getScreenCols();
  local topY, lineSpacing, colWidth, screenFont = 
    self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont();

  self.setTextColorBlack();
  setTextAlignment(RenderText.ALIGN_LEFT);
  setTextBold(true);
  renderText(screenCols[1], topY - lineSpacing, screenFont,
    g_i18n:getText("StorageFillType"));
  setTextAlignment(RenderText.ALIGN_RIGHT);
  renderText(screenCols[3] + colWidth, topY - lineSpacing, screenFont,
    g_i18n:getText("Amount"));
  setTextBold(false);
  
  -- Fruit name column
  local row = 1;
  for i=self.showFruit, math.min(#self.fruitsInStorage, self.showFruit + 10) do
    row = row + 1;
    local fruitIndex = self.fruitsInStorage[i];
    self.fruitOverlays[i]:render();
    setTextAlignment(RenderText.ALIGN_LEFT);
    renderText(self.getOffsetX() + (lineSpacing / g_screenAspectRatio + self.getMargin()), topY - lineSpacing * row, screenFont,
      Fillable.fillTypeIndexToDesc[fruitIndex].nameI18N);
    setTextAlignment(RenderText.ALIGN_RIGHT);
    renderText(screenCols[3] + colWidth, topY - lineSpacing * row, screenFont,
      g_i18n:formatNumber(g_currentMission:getSiloAmount(fruitIndex)));
  end;
end;

VG_PDA_storageScreen:registerScreen(g_i18n:getText("StorageLiter")); -- TODO: Double checl translation
addModEventListener(VG_PDA_storageScreen);


-- #######################
-- # VG_PDA_priceScreen
-- #######################
local priceArrowDown = "dataS2/menu/hud/hud_pda_priceArrow_down.png";
local priceArrowFlat = "dataS2/menu/hud/hud_pda_priceArrow_flat.png";
local priceArrowUp = "dataS2/menu/hud/hud_pda_priceArrow_up.png";

local VG_PDA_priceScreen = VG_PDA_Screen:new();
function VG_PDA_priceScreen:loadMap()
  local i18n;
  if g_currentMission.missionInfo.customEnvironment ~= nil then
    i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
  else
    i18n = g_i18n;
  end;
  
  self.fruitsInEconomySellable = {}; --TODO make local
  self.fruitsInEconomy = {};
  self.fruitOverlays = {};
  self.sellLocations = {};
  self.arrowOverlays = {};
  
  self.isActive = false;
  self.currentHour = 0;
  self.currentDay = 0;
  self.showStation = 1;
  self.showFruit = 1;

  self.overlay = Overlay:new("VG_PDA_priceScreen", Utils.getFilename('VG_PDA_storage.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
  
  setTextBold(true);
  for _, location in pairs(g_currentMission.tipTriggers) do
    if (location.appearsOnPDA) then
      -- add fruits here instead
      local hasFruitsInEconomy = false;
      for index, _ in pairs(location.acceptedFillTypes) do
        local fruit = Fillable.fillTypeIndexToDesc[index];
        if fruit.partOfEconomy or index == Fillable.FILLTYPE_SILAGE then
          self.fruitsInEconomySellable[index] = fruit;
          hasFruitsInEconomy = true;
        end;
      end;

      if hasFruitsInEconomy then
        local locationName = location.stationName;
        if i18n:hasText(location.stationName) then
          locationName = i18n:getText(location.stationName);
        end;
        
        if getTextLineLength(self.getScreenFont(), locationName, self.getColWidth() - self.getMargin()) == utf8Strlen(locationName) then
          locationName = "\n"..locationName;
        else
          locationName = self.textWrap(locationName, self.getScreenFont(), self.getColWidth() - self.getMargin());
        end;
       
        table.insert(self.sellLocations, {name = locationName, tipTrigger = location});
      end;
    end;
  end;
  setTextBold(false);
    
  local i = 0;
  for index, fruit in pairs(self.fruitsInEconomySellable) do
    i = i + 1;
    table.insert(self.fruitsInEconomy, index);
    table.insert(self.fruitOverlays, 
      Overlay:new(
        fruit.name, 
        fruit.hudOverlayFilenameSmall, 
        self.getOffsetX() + self.getLineSpacing() / g_screenAspectRatio + self.getMargin(), self.getTopY() - self.getLineSpacing() * ((i-1) % 10 + 3),
        self.getLineSpacing() / g_screenAspectRatio, self.getLineSpacing()));
    self.fruitOverlays[i]:setColor(0, 0, 0, 1);
  end;
  
  table.sort(self.sellLocations, function (a,b) return a.name:gsub("\n?(.*)","%1") < b.name:gsub("\n?(.*)","%1") end);
  g_currentMission.environment:addHourChangeListener(self);
end;

function VG_PDA_priceScreen:activate()
  self.isActive = true;
  if self.currentHour ~= g_currentMission.environment.currentHour or self.currentDay ~= g_currentMission.environment.currentDay then
    self.currentHour = g_currentMission.environment.currentHour;
    self.currentDay = g_currentMission.environment.currentDay;
    
    for i, fruitIndex in ipairs(self.fruitsInEconomy) do
      local pricePerLiter = Fillable.fillTypeIndexToDesc[fruitIndex].pricePerLiter;
      local previousHourPrice = Fillable.fillTypeIndexToDesc[fruitIndex].previousHourPrice;
      local arrowFile = priceArrowFlat;
      local priceChange = pricePerLiter - previousHourPrice;
      
      if (priceChange < -pricePerLiter * 0.01) then
        arrowFile = priceArrowDown;
      elseif (priceChange > pricePerLiter * 0.01) then
        arrowFile = priceArrowUp;
      end;
      
      if (self.arrowOverlays[i] ~= nil) then self.arrowOverlays[i]:delete(); end;
      self.arrowOverlays[i] = Overlay:new(
        "priceArrow"..i,
        arrowFile,
        self.getOffsetX(), self.getTopY() - self.getLineSpacing() * ((i-1) % 10 + 3),
        self.getLineSpacing() / g_screenAspectRatio, self.getLineSpacing());      
    end;
  end;
end;

function VG_PDA_priceScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_priceScreen:hourChanged()
  if self.isActive then
    --self:deactivate();
    self:activate();
  end;
end;

function VG_PDA_priceScreen:update()
  if self.isActive then
    if #self.sellLocations > 3 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextStations"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevStations"), InputBinding.VG_PDA_PREV_PAGE);
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showStation = self.showStation + 3;
        if self.showStation > #self.sellLocations then
          self.showStation = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showStation = self.showStation - 3;
        if self.showStation < 1 then
          self.showStation = math.floor((#self.sellLocations - 1) / 3) * 3 + 1;
        end;
      end;
    end;
    if #self.fruitsInEconomy > 9 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextFruits"), InputBinding.VG_PDA_MORE_INFO);
      if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
        self.showFruit = self.showFruit + 10;
        if self.showFruit > #self.fruitsInEconomy then
          self.showFruit = 1;
        end;
      end;
    end;
  end;
end;

function VG_PDA_priceScreen:draw()
  if not self.isActive then return end;
  
  self.overlay:render();
  self.setTextColorBlack();
  local screenCols = self.getScreenCols();
  local topY, lineSpacing, colWidth, screenFont = 
    self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont();
  local difficultyMultiplier = math.max(2 * (3 - g_currentMission.missionStats.difficulty), 1); -- from TipTrigger.lua

  setTextAlignment(RenderText.ALIGN_LEFT);
  setTextBold(true);
  renderText(screenCols[1], topY - lineSpacing * 2, screenFont,
    g_i18n:getText("StorageFillType"));
  setTextBold(false);
  
  -- Fruit name column
  local row = 2;
  for i=self.showFruit, math.min(#self.fruitsInEconomy, self.showFruit + 9) do
    row = row + 1;
    local fruitIndex = self.fruitsInEconomy[i];
    self.fruitOverlays[i]:render();
    self.arrowOverlays[i]:render();
    renderText(self.getOffsetX() + (lineSpacing / g_screenAspectRatio + self.getMargin()) * 2, topY - lineSpacing * row, screenFont,
      Fillable.fillTypeIndexToDesc[fruitIndex].nameI18N);
  end;
  
  setTextAlignment(RenderText.ALIGN_RIGHT);
  local column = 1;
  for i=self.showStation, math.min(#self.sellLocations, self.showStation + 2) do
    column = column + 1;
    local tipTrigger = self.sellLocations[i].tipTrigger;
    setTextBold(true);
    renderText(screenCols[column] + colWidth, topY - lineSpacing, screenFont, self.sellLocations[i].name);
    setTextBold(false);
    row = 2;
    for j=self.showFruit, math.min(#self.fruitsInEconomy, self.showFruit + 9) do
      row = row + 1;
      local fruitIndex = self.fruitsInEconomy[j];
      local priceMultiplier = tipTrigger.priceMultipliers[fruitIndex];
      if priceMultiplier ~= nil then
        local greatDemandMultiplier = 1;
        local greatDemand = g_currentMission.economyManager:getCurrentGreatDemand(tipTrigger.stationName, fruitIndex);
        if greatDemand ~= nil then
          self.setTextColorGreen();
          greatDemandMultiplier = greatDemand.demandMultiplier;
          setTextAlignment(RenderText.ALIGN_LEFT);
          renderText(screenCols[column] + self.getMargin(), topY - lineSpacing * row, screenFont,
            string.format(' (x%.1f)', greatDemandMultiplier));
          self.setTextColorBlack();
          setTextAlignment(RenderText.ALIGN_RIGHT);
        end;
        renderText(screenCols[column] + colWidth, topY - lineSpacing * row, screenFont,
          g_i18n:formatMoney(math.ceil(Fillable.fillTypeIndexToDesc[fruitIndex].pricePerLiter * priceMultiplier * difficultyMultiplier * greatDemandMultiplier * 1000)));
      end;
    end;
  end;
end;

function VG_PDA_priceScreen:deleteMap()

  self.sellLocations = nil;
  self.fruitsInEconomySellable = nil;
  self.fruitsInEconomy = nil;

  for _, overlay in ipairs(self.fruitOverlays) do
    overlay:delete();
  end;
  self.fruitOverlays = nil;

  for _, overlay in ipairs(self.arrowOverlays) do
    overlay:delete();
  end;
  self.arrowOverlays = nil;
  
  self.overlay:delete();
  self.overlay = nil;
  -- g_currentMission.environment:removeHourChangeListener(self);
end;

VG_PDA_priceScreen:registerScreen(g_i18n:getText("helpLineTitle10") .. ' ('..g_i18n:getCurrencySymbol(true)..'/t)');
addModEventListener(VG_PDA_priceScreen);


-- #######################
-- # VG_PDA_financeScreen
-- #######################
local VG_PDA_financeScreen = VG_PDA_Screen:new();
function VG_PDA_financeScreen:loadMap()
  self.isActive = false;
  
  self.overlay = Overlay:new("VG_PDA_financeScreen", Utils.getFilename('VG_PDA_finance.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
end;

function VG_PDA_financeScreen:deleteMap()
  self.overlay:delete();
  self.overlay = nil;
end;

function VG_PDA_financeScreen:activate()
  self.isActive = true;
  self.showDay = 1;
  self:setTitle(g_i18n:getText("finances") .. " - " .. g_i18n:getText("financesToday"));
end;

function VG_PDA_financeScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_financeScreen:update()
  if self.isActive then
    local numDays = math.min(#g_currentMission.missionStats.financeStatsHistory + 1, 7);
    if self.showDay < numDays then
        g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPreviousDayFinances"), InputBinding.VG_PDA_NEXT_PAGE);
    end;
    if self.showDay > 1 then
        g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextDayFinances"), InputBinding.VG_PDA_PREV_PAGE);
    end;
    if (InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) and self.showDay < numDays) or 
       (InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) and self.showDay > 1) then
      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showDay = self.showDay + 1;
        if self.showDay > numDays then
          self.showDay = numDays;
        end;
      elseif InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showDay = self.showDay - 1;
        if self.showDay < 1 then
          self.showDay = 1;
        end;
      end;
      self.dayOfWeek = math.mod(g_currentMission.environment.currentDay - self.showDay, 7) + 1;
      if self.showDay == 1 then
        self:setTitle(g_i18n:getText("finances") .. " - " .. g_i18n:getText("financesToday"));
      else
        self:setTitle(g_i18n:getText("finances") .. " - " .. g_i18n:getText("financesDay" .. self.dayOfWeek));
      end;
    end;
  end;
end;

function VG_PDA_financeScreen:draw()
  if self.isActive then
    self.overlay:render();
    local screenCols = self.getScreenCols();
    local topY, lineSpacing, colWidth, screenFont, margin = 
      self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont(), self.getMargin()
    local financeStats = g_currentMission.missionStats.financeStats;
    local financeStatsHistory = g_currentMission.missionStats.financeStatsHistory;
    local total = 0;
    for i = 1, #financeStats.statNames do
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * i, screenFont, financeStats.statNamesI18n[i]);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      local amount;
      if self.showDay == 1 then
        amount = financeStats[financeStats.statNames[i]];
      else
        amount = financeStatsHistory[#financeStatsHistory - self.showDay + 2][financeStats.statNames[i]];
      end;

      if  amount < 0 then
        self.setTextColorRed();
      end;
      
      renderText(screenCols[4] + colWidth - margin, topY - lineSpacing * i, screenFont, g_i18n:formatMoney(amount));
      total = total + amount;
    end;
    self.setTextColorBlack();
    setTextAlignment(RenderText.ALIGN_LEFT);
    setTextBold(true);
    renderText(screenCols[1], topY - lineSpacing * 11, screenFont, g_i18n:getText("Total"));
    setTextBold(false);
    setTextAlignment(RenderText.ALIGN_RIGHT);
    if total < 0 then
      self.setTextColorRed();
    else
      self.setTextColorBlack();
    end;
    renderText(screenCols[4] + colWidth - margin, topY - lineSpacing * 11, screenFont, g_i18n:formatMoney(total));
    if self.showDay == 1 then
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      setTextBold(true);
      renderText(screenCols[1], topY - lineSpacing * 12, screenFont, g_i18n:getText("Balance"));
      setTextAlignment(RenderText.ALIGN_RIGHT);
      local balance = g_currentMission.missionStats.money;
      if balance < 0 then
        self.setTextColorRed();
      else
        self.setTextColorBlack();
      end;
      renderText(screenCols[4] + colWidth - margin, topY - lineSpacing * 12, screenFont, g_i18n:formatMoney(balance));
      setTextBold(false);
    end;
  end;
end;

VG_PDA_financeScreen:registerScreen(g_i18n:getText("finances") .. " - " .. g_i18n:getText("financesToday"));
addModEventListener(VG_PDA_financeScreen);


-- #######################
-- # VG_PDA_animalScreen
-- #######################
local VG_PDA_animalScreen = VG_PDA_Screen:new();
function VG_PDA_animalScreen:loadMap()
  self.isActive = false;
  self.showPage = 1;
  self.numAnimals = 0;
  self.animalIndexToName = {};
  self.cowSilos = {};
  self.showUsage = false;
  
  self.overlay = Overlay:new("VG_PDA_animalScreen", Utils.getFilename('VG_PDA_storage.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
  
  if g_currentMission.husbandries ~= nil then
    for k, v in pairs(g_currentMission.husbandries) do
      if v.typeName ~= nil then
        table.insert(self.animalIndexToName, k);
      end;
    end;
    self.numAnimals = #self.animalIndexToName;
  end;
  local objects = g_currentMission.onCreateLoadedObjects;
  local bunkerSiloClass = BunkerSilo.classId;
  for _, v in pairs(objects) do
    if v.classId == bunkerSiloClass then
      if getName(v.nodeId) == "cowSilo01" then
        table.insert(self.cowSilos, v);
      end;
    end;
  end;
end;

function VG_PDA_animalScreen:deleteMap()
  self.cowSilos = nil;
  self.animalIndexToName = nil;
  self.overlay:delete();
  self.overlay = nil;
end;

function VG_PDA_animalScreen:activate()
  self.isActive = true;
end;

function VG_PDA_animalScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_animalScreen:update()
  if self.isActive then
    if self.numAnimals > 1 then
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowNextAnimal"), InputBinding.VG_PDA_NEXT_PAGE);
      g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowPrevAnimal"), InputBinding.VG_PDA_PREV_PAGE);

      if InputBinding.hasEvent(InputBinding.VG_PDA_NEXT_PAGE) then
        self.showPage = self.showPage + 1;
        if self.showPage > self.numAnimals then
          self.showPage = 1;
        end;
      end;
      if InputBinding.hasEvent(InputBinding.VG_PDA_PREV_PAGE) then
        self.showPage = self.showPage - 1;
        if self.showPage < 1 then
          self.showPage = self.numAnimals;
        end;
      end;
    end;
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowMoreStats"), InputBinding.VG_PDA_MORE_INFO);
    if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
      self.showUsage = not self.showUsage;
    end;
  end;
end;

function VG_PDA_animalScreen:draw()
  if self.isActive then
    local i18n;
    if g_currentMission.missionInfo.customEnvironment ~= nil then
      i18n = _G[g_currentMission.missionInfo.customEnvironment].g_i18n;
    else
      i18n = g_i18n;
    end;
    
    self.overlay:render();
    
    local screenCols = self.getScreenCols();
    local topY, lineSpacing, colWidth, screenFont, margin, offsetX, screenWidth = 
      self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont(), self.getMargin(), self.getOffsetX(), self.getWidth();
    local amountCol = screenCols[4] - 0.007;
    self.setTextColorBlack();
    setTextAlignment(RenderText.ALIGN_LEFT);      
    if self.numAnimals == 0 then
      renderText(screenCols[1], topY - lineSpacing, screenFont, "No Animals"); --TODO i18n or deregister
      return;
    end;
    
    local difficultyMultiplier = Utils.lerp(0.6, 1, (g_currentMission.missionStats.difficulty-1)/2); -- from Hirable.lua
    local animalName = self.animalIndexToName[self.showPage];
    local animal = g_currentMission.husbandries[animalName];
    local fluid_unit_short = " [" .. i18n:getText("fluid_unit_short") .. "]";
    local currentLine = 1;
    setTextAlignment(RenderText.ALIGN_LEFT);
    renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText(animalName .. "_owned"));
    setTextAlignment(RenderText.ALIGN_RIGHT);
    renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(animal.totalNumAnimals));
    currentLine = currentLine + 1;
    
    -- add animal.tipTriggersFillLevels[Fillable.FILLTYPE_WATER] to check for WaterMod
    if animalName ~= "chicken" or animal.tipTriggersFillLevels[Fillable.FILLTYPE_WATER] then
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Productivity"));
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, string.format("%d", math.floor(animal.productivity * 100)));
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "%");
      currentLine = currentLine + 1;
    end;
    
    if animal.useCowFeeding then
      -- FORAGE
      local capacity, fillPercentage = 0, 0;
      local forageFillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_FORAGE)));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("FeedingTroughForage_storage") .. fluid_unit_short);
      if g_forageUsagePerAnimalPerDay[animalName] ~= nil and animal.totalNumAnimals > 0 then
        capacity = g_forageUsagePerAnimalPerDay[animalName] * math.max(animal.totalNumAnimals, 15) * 6;
        fillPercentage = 100 * forageFillLevel / capacity;
        if fillPercentage < 16.66666 then
          self.setTextColorRed();
        elseif fillPercentage < 33.33333 then
          self.setTextColorYellow();
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(forageFillLevel));
      if capacity > 0 then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usage = animal.totalNumAnimals * g_forageUsagePerAnimalPerDay[animalName] * difficultyMultiplier;
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
      
      -- SILAGE
      capacity, fillPercentage = 0, 0;
      silageFillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_SILAGE)));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("FeedingTroughSilage_storage") .. fluid_unit_short);
      if g_silageUsagePerAnimalPerDay[animalName] ~= nil and animal.totalNumAnimals > 0 then
        capacity = g_silageUsagePerAnimalPerDay[animalName] * math.max(animal.totalNumAnimals, 15) * 6;
        fillPercentage = 100 * silageFillLevel / capacity;
        if forageFillLevel == 0 then
          if fillPercentage < 16.66666 then
            self.setTextColorRed();
          elseif fillPercentage < 33.33333 then
            self.setTextColorYellow();
          end;
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(silageFillLevel));
      if capacity > 0 then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usage = animal.totalNumAnimals * g_silageUsagePerAnimalPerDay[animalName] * difficultyMultiplier;
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
      
      -- GRASS
      capacity, fillPercentage = 0, 0;
      fillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_GRASS_WINDROW)));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("FeedingTroughGrass_storage") .. fluid_unit_short);
      if g_grassUsagePerAnimalPerDay[animalName] ~= nil and animal.totalNumAnimals > 0 then
        capacity = g_grassUsagePerAnimalPerDay[animalName] * math.max(animal.totalNumAnimals, 15) * 6;
        fillPercentage = 100 * fillLevel / capacity;
        if forageFillLevel == 0 and silageFillLevel == 0 then
          if fillPercentage < 16.66666 then
            self.setTextColorRed();
          elseif fillPercentage < 33.33333 then
            self.setTextColorYellow();
          end;
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      if capacity > 0 then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usage = animal.totalNumAnimals * g_grassUsagePerAnimalPerDay[animalName] * difficultyMultiplier;
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
    elseif animalName ~= "chicken" then
      local capacity, fillPercentage = 0, 0;
      local fillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_FORAGE)));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("FeedingTroughMisc_storage") .. fluid_unit_short);
      if g_forageUsagePerAnimalPerDay[animalName] ~= nil and animal.totalNumAnimals > 0 then
        capacity = g_forageUsagePerAnimalPerDay[animalName] * math.max(animal.totalNumAnimals, 15) * 6;
        fillPercentage = 100 * fillLevel / capacity;
        if fillPercentage < 16.66666 then
          self.setTextColorRed();
        elseif fillPercentage < 33.33333 then
          self.setTextColorYellow();
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      if capacity > 0 then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usage = animal.totalNumAnimals * g_forageUsagePerAnimalPerDay[animalName] * difficultyMultiplier;
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
    end;
    
    -- Extra for WaterMod
    local Needs;
    if WaterMod and WaterMod.WaterMod.Needs and WaterMod.WaterMod.Needs then
      Needs = WaterMod.WaterMod.Needs;
    elseif g_currentMission.missionInfo.customEnvironment and 
           g_currentMission.missionInfo.customEnvironment.WaterMod then
      Needs = g_currentMission.missionInfo.customEnvironment.WaterMod.Needs;
    else
      Needs = { ["cow"]={[Fillable.FILLTYPE_WATER]=60},
                ["sheep"]={[Fillable.FILLTYPE_WATER]=10},
                ["chicken"]={[Fillable.FILLTYPE_WATER]=1,[Fillable.FILLTYPE_WHEAT]=0.5}};
    end;
    if animal.tipTriggersFillLevels[Fillable.FILLTYPE_WATER] ~= nil then
      local fillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_WATER)));
      local capacity, fillPercentage;
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("water_fill_level") .. fluid_unit_short);
      if Needs[animalName] and Needs[animalName][Fillable.FILLTYPE_WATER] ~= nil and animal.totalNumAnimals > 0 then
        capacity = Needs[animalName][Fillable.FILLTYPE_WATER] * animal.totalNumAnimals * 6;
        fillPercentage = 100 * fillLevel / capacity;
        if fillPercentage < 16.66666 then
          self.setTextColorRed();
        elseif fillPercentage < 33.33333 then
          self.setTextColorYellow();
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      if capacity then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(capacity / 6));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
    end;
    if animal.tipTriggersFillLevels[Fillable.FILLTYPE_WHEAT] ~= nil then
      local fillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_WHEAT)));
      local capacity, fillPercentage;
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Wheat_storage") .. fluid_unit_short);     
      if Needs[animalName] and Needs[animalName][Fillable.FILLTYPE_WHEAT] ~= nil and animal.totalNumAnimals > 0 then
        capacity = Needs[animalName][Fillable.FILLTYPE_WHEAT] * animal.totalNumAnimals * 6;
        fillPercentage = 100 * fillLevel / capacity;
        if fillPercentage < 16.66666 then
          self.setTextColorRed();
        elseif fillPercentage < 33.33333 then
          self.setTextColorYellow();
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      if capacity then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(capacity / 6));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      currentLine = currentLine + 1;
    end;
    -- End WaterMod
    local hasStraw = false;
    if animal.tipTriggersFillLevels[Fillable.FILLTYPE_WHEAT_WINDROW] ~= nil then
      local fillLevel = math.floor(i18n:getFluid(animal:getFillLevel(Fillable.FILLTYPE_WHEAT_WINDROW)));
      local capacity, fillPercentage;
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Straw_storage") .. fluid_unit_short);
      if g_strawUsagePerAnimalPerDay[animalName] ~= nil and animal.totalNumAnimals > 0 then
        capacity = g_strawUsagePerAnimalPerDay[animalName] * math.max(animal.totalNumAnimals, 15) * 6;
        fillPercentage = 100 * fillLevel / capacity;
        if fillPercentage < 16.66666 then
          self.setTextColorRed();
        elseif fillPercentage < 33.33333 then
          self.setTextColorYellow();
        end;
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      if capacity then
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        if self.showUsage then
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          local usage = animal.totalNumAnimals * g_strawUsagePerAnimalPerDay[animalName] * difficultyMultiplier;
          local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
          renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
        else
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
          renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        end;
      end;
      if fillLevel > 0 then
        hasStraw = true;
      end;
      currentLine = currentLine + 1;
    end;
    
    if animal.liquidManureTrigger ~= nil then
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("LiquidManure_storage") .. fluid_unit_short);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      local fillLevel = math.floor(i18n:getFluid(animal.liquidManureTrigger.fillLevel));
      local capacity = math.floor(i18n:getFluid(animal.liquidManureTrigger.capacity));
      local fillPercentage = 100 * fillLevel / capacity;
      if fillPercentage > 99 then
        self.setTextColorRed();
      elseif fillPercentage > 75 then
        self.setTextColorYellow();
      end;
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      if self.showUsage and g_liquidManureLitersPerAnimalPerDay[animalName] then
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        local usage = animal.totalNumAnimals * g_liquidManureLitersPerAnimalPerDay[animalName];
        local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));        
        renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
      else
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
        renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
      end;
      currentLine = currentLine + 1;
    end;
    
    if animal.manureHeap ~= nil then
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Manure_storage") .. fluid_unit_short);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      local fillLevel = math.floor(i18n:getFluid(animal.manureHeap.fillLevel));
      local capacity = math.floor(i18n:getFluid(animal.manureHeap.capacity));
      local fillPercentage = 100 * fillLevel / capacity;
      if fillPercentage > 99 then
        self.setTextColorRed();
      elseif fillPercentage > 75 then
        self.setTextColorYellow();
      end;
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      if self.showUsage and g_manureLitersPerAnimalPerDay[animalName] then
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        local usage = 0;
        if hasStraw then usage = animal.totalNumAnimals * g_manureLitersPerAnimalPerDay[animalName]; end;
        local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
        renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
      else
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
        renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
      end;
      currentLine = currentLine + 1;
    end;
    
    if animal.palletSpawnerId ~= nil then
      local fillTypeI18N = Fillable.fillTypeIndexToDesc[animal.palletFillType].nameI18N;
      if animal.isServer then
        do
          self.setTextColorBlack();
          setTextAlignment(RenderText.ALIGN_LEFT);
          renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, fillTypeI18N);
          local fillLevel = 0;
          local capacity, fillPercentage;
          if animal.currentPallet ~= nil then
            fillLevel = math.floor(animal.currentPallet:getFillLevel());
            capacity = math.floor(animal.currentPallet:getCapacity());
            fillPercentage = 100 * fillLevel / capacity;
            if fillPercentage > 95 then
              self.setTextColorRed();
            elseif fillPercentage > 75 then
              self.setTextColorYellow();
            end;
          end;
          setTextAlignment(RenderText.ALIGN_RIGHT);
          renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
          self.setTextColorBlack();
          setTextAlignment(RenderText.ALIGN_LEFT);
          if self.showUsage and g_palletFillLevelPerAnimalPerDay[animalName] then
            renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
            setTextAlignment(RenderText.ALIGN_RIGHT);
            local usage = g_palletFillLevelPerAnimalPerDay[animalName] * animal.totalNumAnimals * animal.productivity
            local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
            renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
          elseif capacity then
            renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
            setTextAlignment(RenderText.ALIGN_RIGHT);
            renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
            renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
          end;
        end;
      else
        setTextAlignment(RenderText.ALIGN_LEFT);
        self.setTextColorBlack();
        renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, fillTypeI18N);
        local fillPercentage = animal.currentPalletFillPercentage;
        if fillPercentage > 99 then
          self.setTextColorRed();
        elseif fillPercentage > 75 then
          self.setTextColorYellow();
        end;
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, string.format("%1.0f", animal.currentPalletFillPercentage));
        setTextAlignment(RenderText.ALIGN_LEFT);
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "%");
      end;
      currentLine = currentLine + 1;
    end;
    
    if animal.pickupObjectsId ~= nil then
      local fillTypeI18N = Fillable.fillTypeIndexToDesc[animal.pickupObjectsFillType].nameI18N;
      local fillLevel = animal.numActivePickupObjects;
      local capacity = getNumOfChildren(animal.pickupObjectsId);
 
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, fillTypeI18N);
      local fillPercentage = math.floor(100 * fillLevel / capacity);
      if fillPercentage > 99 then
        self.setTextColorRed();
      elseif fillPercentage > 75 then
        self.setTextColorYellow();
      end;
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
      self.setTextColorBlack()
      setTextAlignment(ALIGN_LEFT);
      if self.showUsage and g_pickupObjectsPerAnimalPerDay[animalName] then
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        local usage = g_pickupObjectsPerAnimalPerDay[animalName] * (animal.totalNumAnimals - 1) * animal.productivity;
        local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
        renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
      else
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
        renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
      end;
      currentLine = currentLine + 1;
    end;
    
    if animalName == "chicken" then
      local fillLevel = g_currentMission:getSiloAmount(Fillable.FILLTYPE_EGG);
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Eggs_carrying"));
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
    end;
    
    if animalName == "cow" then
      for _, cowSilo in ipairs(self.cowSilos) do
        if currentLine > 11 then break; end;
      
        local fillLevel = cowSilo.fillLevel;
        local capacity =  cowSilo.capacity;
        local fillPercentage = math.floor(100 * fillLevel / capacity);
        
        self.setTextColorBlack();
        setTextAlignment(RenderText.ALIGN_LEFT);
        renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("bunkersilo") .. fluid_unit_short);
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(fillLevel));
        setTextAlignment(RenderText.ALIGN_LEFT);
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, " /");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        renderText(screenCols[4] + 0.0475, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(capacity));
        renderText(offsetX + screenWidth - 0.0025, topY - lineSpacing * currentLine, screenFont, string.format("(%1.0f%%)", fillPercentage));
        currentLine = currentLine + 1;
      end;
    end;
        
    if animal.produceMilk then
      self.setTextColorBlack();
      setTextAlignment(RenderText.ALIGN_LEFT);
      renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, i18n:getText("Milk_storage") .. fluid_unit_short);
      setTextAlignment(RenderText.ALIGN_RIGHT);
      renderText(amountCol, topY - lineSpacing * currentLine, screenFont, i18n:formatNumber(math.floor(i18n:getFluid(animal.fillLevelMilk))));
      if self.showUsage and g_milkLitersPerAnimalPerDay[animalName] then
        setTextAlignment(RenderText.ALIGN_LEFT);
        renderText(amountCol, topY - lineSpacing * currentLine, screenFont, "@");
        setTextAlignment(RenderText.ALIGN_RIGHT);
        local usage = g_milkLitersPerAnimalPerDay[animalName] * animal.totalNumAnimals * animal.productivity;
        local usageText = string.format(i18n:getText("shop_maintenance_value"), i18n:formatNumber(usage));
        renderText(offsetX + screenWidth - 0.0124, topY - lineSpacing * currentLine, screenFont, usageText);
      end;
      currentLine = currentLine + 1;
    end
  end;
end;

VG_PDA_animalScreen:registerScreen(g_i18n:getText("statisticView6"));
addModEventListener(VG_PDA_animalScreen);


-- #######################
-- # VG_PDA_statsScreen
-- #######################
local VG_PDA_statsScreen = VG_PDA_Screen:new();
function VG_PDA_statsScreen:loadMap()
  self.isActive = false;
  self.showPage = 1;
  
  self.overlay = Overlay:new("VG_PDA_statsScreen", Utils.getFilename('VG_PDA_storage.png', VG_PDA.moddir), self.getOffsetX(), self.getOffsetY(), self.getWidth(), self.getHeight());
end;

function VG_PDA_statsScreen:delete()
  self.overlay:delete();
  self.overlay = nil;
end;

function VG_PDA_statsScreen:activate()
  self.isActive = true;
  self.statData = g_currentMission.missionStats:getStatisticData();
end;

function VG_PDA_statsScreen:deactivate()
  self.isActive = false;
end;

function VG_PDA_statsScreen:update()
  if self.isActive then
    g_currentMission:addHelpButtonText(g_i18n:getText("PDAShowMoreStats"), InputBinding.VG_PDA_MORE_INFO);
    if InputBinding.hasEvent(InputBinding.VG_PDA_MORE_INFO) then
      self.showPage = self.showPage + 11;
      if self.showPage > #g_currentMission.missionStats.statisticData then
        self.showPage = 1;
      end;
    end;
  end;
end;

function VG_PDA_statsScreen:draw()
  if not self.isActive then return; end;
  
  self.overlay:render();
  
  local screenCols = self.getScreenCols();
  local topY, lineSpacing, colWidth, screenFont, margin = 
    self.getTopY() + self.getMargin(), self.getLineSpacing(), self.getColWidth(), self.getScreenFont(), self.getMargin()
  
  self.setTextColorBlack();
  setTextAlignment(RenderText.ALIGN_RIGHT);
  setTextBold(true);
  renderText(screenCols[3] + colWidth, topY - lineSpacing, screenFont, g_i18n:getText("Session"));
  renderText(screenCols[4] + colWidth, topY - lineSpacing, screenFont, g_i18n:getText("Total"));
  setTextBold(false);
  
  local currentLine = 2;
  for i=self.showPage, math.min(#self.statData, self.showPage + 10) do
    setTextAlignment(RenderText.ALIGN_LEFT);
    renderText(screenCols[1], topY - lineSpacing * currentLine, screenFont, self.statData[i].name);
    setTextAlignment(RenderText.ALIGN_RIGHT);
    renderText(screenCols[3] + colWidth, topY - lineSpacing * currentLine, screenFont, self.statData[i].valueSession);
    renderText(screenCols[4] + colWidth, topY - lineSpacing * currentLine, screenFont, self.statData[i].valueTotal);
    currentLine = currentLine + 1;
  end;
end;

VG_PDA_statsScreen:registerScreen(g_i18n:getText("statistics"));
addModEventListener(VG_PDA_statsScreen);


-- #######################
-- # Debug
-- #######################
if fileExists(VG_PDA.moddir .. 'debug.lua') then
  source(VG_PDA.moddir .. 'debug.lua')
end;